library HDUS_KeyHookDLL;

uses
  Windows,
  SysUtils,
  Classes;

{$R *.res}

const
  KeyMap : array[0..45] of WORD = (
  $0000,
  $1064,$1065,$1066,        // ʕ\  d      
  $1068,$1069,$106A,        // 1         2         3
  $106B,$106C,$106D,        // 4         5         6
  $106E,$1076,$0064,        // 7         8         9
  $1067,$0065,$0066,        // 10        11        12
  $1148,$1150,              // ʁ{    ʁ|
  $0148,$0150,              // Ch{      Ch|
  $0067,$0068,              // j[  j
  $0069,$006A,$006B,$006C,  //       ؑ  EPG       ߂
  $0148,$014B,$014D,$0150,  //                         
  $001C,                    // 
  $006D,$006E,              // ^      
  $0076,$3064,$3065,        // ~      Đ      ꎞ~
  $3066,$3067,$3068,$3069,  // |<<       <<        >>        >>|
  $306A,$306B,              //     Wv
  $306C,$306D,$306E,$3076   // A         B         C         D
);

const
  WM_APP_REMOTEKEY  = $8009;

var
  Hook: HHOOK;
  Shift2A: Boolean;
  Shift3A: Boolean;
  hWndFile: THandle;
  hWnd: THandle;

procedure SetRemoteMessageWnd(Wnd:THandle); stdcall;
var
  P: Pointer;
begin
  hWnd := Wnd;
  if (hWndFile<>0) then
  begin
    P := MapViewOfFile( hWndFile, FILE_MAP_WRITE, 0, 0, 0 );
    if P <> nil then
    begin
      CopyMemory( P, @hWnd, SizeOf( hWnd ) );
      UnmapViewOfFile( P );
    end;
  end;
end;

function KeyHookProc(nCode: Integer; wParam: WPARAM;
                                    lParam: LPARAM): LRESULT; stdcall;
var
  KCode :WORD;
  Press :Boolean;
  i     :WORD;
begin
  if nCode < 0 then
  begin
    result := CallNextHookEx(Hook,nCode,wParam,lParam);
    exit;
  end;

  if (nCode = HC_ACTION) then
  begin
    KCode := (lParam shr 16) and $1FF;
    Press := ((lParam and $80000000)=0);
    if (KCode = $2A) then
    begin
      if Press then Shift2A := True else Shift2A := False;
    end
      else if (KCode = $3A) then
    begin
      if Press then Shift3A := True else Shift3A := False;
    end
      else
    begin
      if (Press) then
      begin
        if Shift2A then KCode := KCode or $1000;
//      if Shift3A then KCode := KCode or $2000;
        for i:=1 to 45 do
        begin
          if (KeyMap[i]=KCode) then
          begin
            if (hWnd<>0) then
            begin
              SendMessage(hWnd, WM_APP_REMOTEKEY, i, 0);
            end;
            break;
          end;
        end;
        Shift3A := False;
      end;
    end;
  end;

  result := CallNextHookEx(Hook,nCode,wParam,lParam);
end;


procedure SetKeyboardHook;
begin
  if Hook <> 0 then exit;
  Shift2A := False;
  Shift3A := False;
  Hook := SetWindowsHookEx(WH_KEYBOARD,@KeyHookProc,hInstance,0);
end;

procedure ResetKeyboardHook;
begin
  if Hook = 0 then exit;
  Shift2A := False;
  Shift3A := False;
  if UnHookWindowsHookEx(Hook) then Hook := 0;
end;

exports
  SetRemoteMessageWnd,
  KeyHookProc,
  SetKeyboardHook,
  ResetKeyboardHook;

procedure DLLEntry(ul_reason_for_call: DWORD);
var
  P: Pointer;
begin
  case ul_reason_for_call of
    DLL_PROCESS_ATTACH:
      begin
        hWndFile := CreateFileMapping( $FFFFFFFF, nil, PAGE_READWRITE,
                      0, SizeOf( hWnd ), 'HDUS_KeyHookDLL_hWND' );
        if (hWndFile<>0) then
        begin
          P := MapViewOfFile( hWndFile, FILE_MAP_WRITE, 0, 0, 0 );
          if P <> nil then
          begin
            CopyMemory( @hWnd, P, SizeOf( hWnd ) );
            UnmapViewOfFile( P );
          end;
        end;
      end;
    DLL_PROCESS_DETACH:
      begin
        CloseHandle(hWndFile);
      end;
    DLL_THREAD_ATTACH:
        ;
    DLL_THREAD_DETACH:
        ;
  end;
end;

begin
  DllProc := @DLLEntry;
  DLLEntry(DLL_PROCESS_ATTACH);
end.

