unit pMainForm;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, IdBaseComponent, IdComponent, IdUDPBase, DateUtils,
  IdUDPServer, IdUDPClient, StdCtrls, ExtCtrls, INIFiles, ShellAPI, Contnrs,
  pProviderCollection, pLogUtils, Winsock, isp3, SegTunerManager_Intf;

const
  WM_APP_REMOTEKEY  = $8009;

type
  TControlForm = class(TForm)
    Panel1: TPanel;
    ChannelNumberLabel: TLabel;
    Panel2: TPanel;
    Timer1: TTimer;
    ProviderNameLabel: TLabel;
    IdUDPClient1: TIdUDPClient;
    RecShape: TShape;
    procedure FormCreate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure Timer1Timer(Sender: TObject);
  private
    { Private 錾 }
    Log             : TLogUtil;
    FProvCollection : TProviderCollection;
    DriverPath      : String;
    TunerCh         : String;
    SegHandle       : DWORD;
    RecHandle       : DWORD;
    InKey           : Integer;
    BefTunerCh      : String;
    //
    FUDPAddr    :String;
    FUDPPort    :Integer;
    FExecPlayer :String;
    FRecFolder  :String;
    procedure ReadSetting;
    procedure WriteSetting;
  public
    { Public 錾 }
    procedure GetRemote(var Msg:TMessage);message WM_APP_REMOTEKEY;
    property  UDPAddr:String      read FUDPAddr    write FUDPAddr;
    property  UDPPort:Integer     read FUDPPort    write FUDPPort;
    property  ExecPlayer:String   read FExecPlayer write FExecPlayer;
    property  RecFolder:String    read FRecFolder  write FRecFolder;
  end;

var
  ControlForm: TControlForm;
  WSAData    : TWSAData; { WinSock ԏ }

procedure SetRemoteMessageWnd(Wnd:THandle); stdcall; external 'HDUS_KeyHookDLL.dll';
procedure SetKeyboardHook; stdcall; external 'HDUS_KeyHookDLL.dll';
procedure ResetKeyboardHook; stdcall; external 'HDUS_KeyHookDLL.dll';

implementation

{$R *.dfm}

function ExecuteProg(App: string): Boolean;
var
  StartupInfo: TStartupInfo;
  ProcessInfo: TProcessInformation;
begin
  GetStartupInfo(StartupInfo);
  if CreateProcess(nil,
                   PChar(App),
                   nil,nil,FALSE,0,nil,
                   PChar(GetCurrentDir),
                   StartupInfo,
                   ProcessInfo) then
  begin
    CloseHandle(ProcessInfo.hThread);
    CloseHandle(ProcessInfo.hProcess);
    Result := True;
  end
    else
  begin
    Result := False;
  end;
end;

procedure TControlForm.ReadSetting;
var
  INI: TINIFile;
begin
  INI := TINIFile.Create(ChangeFileExt(Application.ExeName,'.ini'));
  try
    UDPAddr     := INI.ReadString ('Setting','Address'    ,'127.0.0.1');
    FUDPPort    := INI.ReadInteger('Setting','SendPort'   ,1234);
    FExecPlayer := INI.ReadString ('Setting','ExecPlayer' ,'');
    FRecFolder  := INI.ReadString ('Setting','RecFolder'  ,'');
    if (FRecFolder<>'') then FRecFolder := IncludeTrailingPathDelimiter(FRecFolder);
  except
  end;
  INI.Free;
end;

procedure TControlForm.WriteSetting;
var
  INI: TINIFile;
begin
  INI := TINIFile.Create(ChangeFileExt(Application.ExeName,'.ini'));
  try
    INI.WriteString ('Setting','Address'    ,FUDPAddr    );
    INI.WriteInteger('Setting','SendPort'   ,FUDPPort    );
  except
  end;
  INI.Free;
end;

procedure TControlForm.FormCreate(Sender: TObject);
begin
  DriverPath := IncludeTrailingPathDelimiter(ExtractFilePath(Application.ExeName));
  ReadSetting;
  //
  Log             := TLogUtil.Create;
  Log.LogCallback := nil;
  FProvCollection := TProviderCollection.Create(Log,ChangeFileExt(Application.ExeName,'.ch'));
  BefTunerCh      := '';
  TunerCh         := '';
  SegHandle       := 0;
  RecHandle       := 0;
  InKey           := 0;
  //
  SetRemoteMessageWnd(Handle);
  SetKeyboardHook;
end;

procedure TControlForm.FormDestroy(Sender: TObject);
begin
  WriteSetting;
  ResetKeyboardHook;
end;

procedure TControlForm.GetRemote(var Msg:TMessage);
begin
  InKey := WORD(Msg.WParam);
end;

procedure TControlForm.Timer1Timer(Sender: TObject);
var
  str: String;
  Rem: Integer;
  Ch : String;
  ChFlg : Boolean;
  ChNum : Integer;
  y,m,d,h,n,s,ms: WORD;
begin
  // \{Update
  if (SegHandle=0) or (not Assigned(FProvCollection)) then
  begin
    if (ChannelNumberLabel.Caption<>'') then ChannelNumberLabel.Caption := '';
    if (ProviderNameLabel.Caption <>'') then ProviderNameLabel.Caption := '';
    BefTunerCh := '';
  end
    else
  begin
    str := IntToStr(FProvCollection.ChToRemote(TunerCh));
    if (ChannelNumberLabel.Caption<>str) then ChannelNumberLabel.Caption := str;
    str := FProvCollection.ChToName(TunerCh);
    if (ProviderNameLabel.Caption<>str)  then ProviderNameLabel.Caption := str;
    SegTuner_UpdateTimeout(SegHandle);
  end;
  if (RecHandle=0) then
  begin
    if (RecShape.Visible) then RecShape.Visible := False;
  end
    else
  begin
    if (not RecShape.Visible) then RecShape.Visible := True;
    SegTuner_UpdateTimeout(RecHandle);
  end;

  // L[͏
  if (InKey = 2) then
  begin
    // d{^
    SegTuner_ManagerActivate;
  end
    else if ((InKey >= 4) and (InKey <= 15)) then
  begin
    // `l{^
    Rem := InKey-3;
    Ch := FProvCollection.RemoteToCh(Rem);
    if (Ch<>'') then
    begin
      TunerCh := ch;
      if (BefTunerCh<>TunerCh) then
      begin
        if (Copy(TunerCh,1,1)='C') then
        begin
          ChFlg := True; // cable
          ChNum := StrToIntDef(Copy(TunerCh,2,Length(TunerCh)),0);
        end
          else
        begin
          ChFlg := False; // UHF
          ChNum := StrToIntDef(TunerCh,0);
        end;
        //
        if (SegHandle<>0) then
        begin
          SegTuner_Stop(SegHandle);
          SegHandle := 0;
        end;
        SegTuner_SendUDP(SegTuner_ChannelToFreq(ChNum,ChFlg),True,5,PChar(UDPAddr),UDPPort,SegHandle);
        BefTunerCh := TunerCh;
      end;
    end;
  end
    else if (InKey = 1) then
  begin
    // ʕ\{^
    if (FExecPlayer<>'') then
    begin
      ExecuteProg(FExecPlayer);
    end;
  end
    else if (InKey = 31) then
  begin
    // ^{^
    if (RecHandle = 0) then
    begin
      // ^Jn
      DecodeDateTime(Now,y,m,d,h,n,s,ms);
      if (Copy(TunerCh,1,1)='C') then
      begin
        ChFlg := True; // cable
        ChNum := StrToIntDef(Copy(TunerCh,2,Length(TunerCh)),0);
      end
        else
      begin
        ChFlg := False; // UHF
        ChNum := StrToIntDef(TunerCh,0);
      end;
      str := Format('Ch%.2d-%.4d%.2d%.2d-%.2d%.2d%.2d.ts',[ChNum,y,m,d,h,n,s]);
      str := ExpandFileName(FRecFolder+str);
      SegTuner_SaveFile(SegTuner_ChannelToFreq(ChNum,ChFlg),False,True,5,PChar(str),RecHandle);
    end;
  end
    else if (InKey = 33) then
  begin
    // ~{^
    if (RecHandle <> 0) then
    begin
      SegTuner_Stop(RecHandle);
      RecHandle := 0;
    end;
  end;
  //
  InKey := 0;
end;

end.
