unit SegTunerManager_Intf;

interface

uses
  Windows;

const
  SEGTM_NAME           = 'TSegTunerManagerController';
  SEGTM_EXENAME        = 'SegTunerManager.exe';
  SEGTM_MUTEXNAME      = 'SegTunerManager_mutex';
  SEGTM_EXETIMEOUTSEC  = 60;

  SEGTM_ERROR          = 0;
  SEGTM_OK             = 1;

  SEGTM_ACTIVATEFORM   = 0;
  SEGTM_SAVEFILE       = 1;
  SEGTM_SENDUDP        = 2;
  SEGTM_STOP           = 3;
  SEGTM_UPDATE         = 4;
  SEGTM_PING           = 5;

type
  TSEGTM_SaveFileParam = record
    Frequency  : DWORD;
    AppendMode : WORD;
    B25Mode    : WORD;
    MaxTimeOut : DWORD;
    FileName   : array [0..MAX_PATH-1] of Char;
  end;

  TSEGTM_SendUDPParam = record
    Frequency  : DWORD;
    B25Mode    : WORD;
    Port       : WORD;
    MaxTimeOut : DWORD;
    Address    : array [0..1023] of Char;
  end;

  TSEGTM_HandleParam = record
    Handle     : DWORD;
  end;

function SegTuner_ChannelToFreq(Ch:WORD; IsCATV:BOOL): DWORD; stdcall; external 'SegTunerControl.dll';
function SegTuner_ManagerActivate: Boolean; stdcall; external 'SegTunerControl.dll';
function SegTuner_SaveFile(Freq:DWORD; Append:BOOL; B25Mode:BOOL;
            MaxTimeOut:DWORD; FileName:PChar; var Handle:DWORD): Boolean; stdcall; external 'SegTunerControl.dll';
function SegTuner_SendUDP(Freq:DWORD; B25Mode:BOOL; MaxTimeOut:DWORD; Addr:PChar; Port:WORD; var Handle:DWORD): Boolean; stdcall; external 'SegTunerControl.dll';
function SegTuner_Stop(Handle:DWORD): Boolean; stdcall; external 'SegTunerControl.dll';
function SegTuner_UpdateTimeout(Handle:DWORD): Boolean; stdcall; external 'SegTunerControl.dll';
function SegTuner_ManagerPing: Boolean; stdcall; external 'SegTunerControl.dll';

implementation



end.
